<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html
 PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
 "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
    <!-- Ignored at this stage -->
  </head>
  <body>
    <div id="test-page" class="mainbody">
      <dcc.Interval id="interval-component-run"    interval="int:2000" n_intervals="int:0" />
      <dcc.Interval id="interval-component-status" interval="int:1000" n_intervals="int:0" />

      <dcc.Store id="panel-status" storage_type="session" />
      <dcc.Store id="lviv-last-update" storage_type="memory" />
      <dcc.Store id="lviv-data" storage_type="memory" />
      <dcc.Store id="dac-last-update" storage_type="memory" />
      <dcc.Store id="dac-data" storage_type="memory" />
      <dcc.Store id="dcdc-last-update" storage_type="memory" />
      <dcc.Store id="dcdc-data" storage_type="memory" />
      <dcc.Store id="hvrt-last-update" storage_type="memory" />
      <dcc.Store id="hvrt-data" storage_type="memory" />
      <dcc.Store id="amsl-last-update" storage_type="memory" />
      <dcc.Store id="amsl-data" storage_type="memory" />
      <dcc.Store id="tio-data" storage_type="memory" />
      <dcc.Store id="tio-last-update" storage_type="memory" />
      <dcc.Store id="ven-last-update" storage_type="memory" />
      <dcc.Store id="temp-last-update" storage_type="memory" />
      <dcc.Store id="dcdcadj-last-update" storage_type="memory" />

      <dcc.Store id="panel-dbresult" storage_type="memory" />

      <dcc.Tabs id="tabs" value="0">
	{% for panel in panels %}
        <dcc.Tab id="tab-{{loop.index0}}" label="{{panel}}" value="{{loop.index0}}"/>
	{% endfor %}
      </dcc.Tabs>
      <h1 id="ATLAS-title">ATLAS Powerboard Testing</h1>

      <div id="panel-div">
        <div id="control">
          <!-- Panel information -->
          <div id="panel-information">
            <div style="padding-bottom: 20px; padding-top: 20px">
              <dcc.Input id="panel-number" value="" placeholder="Panel number"/>
              <button id="panel-populate-button">Auto Fill</button>
            </div>

            <div id="auto-fill-msg"/>

            <ul id="version-input">
              <li><dcc.Input id="version" placeholder="Powerboard Version Number" /></li>
              <li><dcc.Input id="batch" placeholder="Powerboard Batch Number" /></li>
            </ul>

            <ul id="serial-input">
              {% for pb in [0,1,2,3,4,5,6,7,8,9] %}
              <li class="pb-serial">
                <dcc.Checklist id="pb-{{pb}}" />
                <dcc.Input id="serial-{{pb}}" placeholder="PB{{pb}} Serial Number"/>
              </li>
              {% endfor %}
            </ul>

            <div style="padding-bottom: 5px; padding-top: 20px; text-align: center">
              <button id="panel-upload-test-result-button">Upload Test Results</button>
            </div>

            <div id="upload-test-msg"/>
            <div id="upload-status-msg"/>


            <div style="padding-bottom: 5px; padding-top: 20px; text-align: center">
              <button id="panel-transition-button">Panel Stage Transition To:</button>
              <dcc.Dropdown id="transition-dropdown" />
              <dcc.Checklist id="force-transition" />
            </div>

            <div id="panel-transition-msg"/>
            <div id="transition-status-msg"/>

          </div>

          <!-- Debug mode options along with test run/stop buttons -->
          <div id="run-information">
            <dcc.RadioItems id="debug" />

            <div class="center">
              <button id="active-test-button">System Initialization</button>
            </div>

            <div id="active-test-msg"/>
            <div id="active-result-msg"/>


            <div class="center">
              <button id="basic-test-button">Run Basic Functionality Test</button>
              <button id="advanced-test-button">Run Characterization Test</button>
              <button id="stop-button">Stop Test</button>
            </div>

            <div class="center">
              <dcc.Dropdown id="specify-test-tag-dropdown" placeholder="Set a tag for this test from dropdown menu"/>
              <dcc.Input id="specify-test-tag" value="" placeholder="Or set a custom test tag"/>
            </div>

            <div class="center">
            <Button id="burnin_button">Burnin</Button>
            <span id="burnin_message" />
            <dcc.Input id="burnin_load" value="" placeholder="load (A)"/>
            <dcc.Input id="burnin_time" value="" placeholder="time (h)"/>
            </div>

            <div id="basic-test-msg"/>
            <div id="advanced-test-msg"/>
            <div id="stop-msg"/>

            <h3>Jump to:</h3>
            <ul>
              <li><a href="#basic-results">Basic Functionality</a></li>
              <li><a href="#gen-results">Generic Tests</a></li>
	      <li><a href="#dac-results">DAC Tests</a></li>
	      <li><a href="#lv-results">DC/DC Tests</a></li>
	      <li><a href="#hv-results">HV Tests</a></li>
              <li><a href="#terminal">Terminal</a></li>
            </ul>
          </div>
          
        </div>

        <!-- Basic functionality tables -->
        <div id="basic-results" class="test-results">
          <h2 class="test-header">Basic Functionality Tests</h2>
          <div class="table-group">
            <dash_table.DashTable id="LVEn-table" />
            <dash_table.DashTable id="tio-table-1" />
            <dash_table.DashTable id="tio-table-2" />
	    <dash_table.DashTable id="temp-table" />
	    <dash_table.DashTable id="dcdcadj-table" />
          </div>
        </div>

	<!-- ADVANCED TESTS -->

        <!-- AMAC Tests -->
        <div id="gen-results" class="test-results">
          <h2 class="test-header">General Tests</h2>
          <div class="graph-group">
            <dcc.Graph id="lviv-graph" />	    
            <dcc.Graph id="amsl-graph" />
          </div>
        </div>

	<!-- DAC Ramps -->
        <div id="dac-results" class="test-results">
          <h2 class="test-header">DAC Ramps</h2>
          <div class="graph-group">
            <dcc.Graph id="shuntx-graph" />
	    <dcc.Graph id="shunty-graph" />
	    <dcc.Graph id="calx-graph" />
	    <dcc.Graph id="caly-graph" />
          </div>
        </div>

        <!-- Low Voltage Tests -->
        <div id="lv-results" class="test-results">
          <h2 class="test-header">DC/DC Tests</h2>
          <div class="graph-group">
            <dcc.Graph id="eff-graph" />
	    <dcc.Graph id="temp-graph" />
            <dash_table.DashTable id="eff-table" />
            <dcc.Graph id="icur-graph" />
            <dcc.Graph id="ocur-graph" />
          </div>
        </div>
	
        <!-- HV Tests -->
        <div id="hv-results" class="test-results">
          <h2 class="test-header">High Voltage Tests</h2>
          <div class="graph-group">
            <dcc.Graph id="gain0-graph" />
            <dcc.Graph id="gain1-graph" />
            <dcc.Graph id="gain2-graph" />
            <dcc.Graph id="gain4-graph" />
          </div>
        </div>
    	
        <!-- Temperature Monitoring -->
        <div id="pb-temp-monitor-results" class="test-results">
          <h2 class="test-header">Temperature Monitoring</h2>
            <table class="center-table">             
            <td>
                <Button id="start_pb_monitor_button">Start Temperature Monitoring</Button>
                <span id="start_pb_monitor_message" />
            </td>
            <td>
                <Button id="stop_pb_monitor_button">Stop Temperature Monitoring</Button>
                <span id="stop_pb_monitor_message" />
            </td>
            <td>
                <Button id="clear_pb_monitor_data_button">Clear Monitoring Data</Button>
                <span id="clear_pb_monitor_data_message" />
            </td>
            <td>
                <td> <dcc.Checklist id="save-csv" /> </td>
            </td>
            <td>
                <td> <dcc.Checklist id="save-influx" /> </td>
            </td>
            </table>

           <table class="center-table">
           <tr>
              <td> Choose what to show: </td>
              <td> <dcc.Checklist id="add-NTCpb" /> </td>
              <td> <dcc.Checklist id="add-PTAT" /> </td>
              <td> <dcc.Checklist id="add-CTAT" /> </td>
              <td> <dcc.Checklist id="add-chiller" /> </td>
            </tr>
            </table>
          <div class="graph-group">
            <dcc.Graph id="pb-temp-monitor-graph" />
          </div>
        </div>
        
    
        <!-- Terminal output -->
        <div id="terminal" class="test-results">
          <h2 class="test-header">Terminal Output</h2>
          <pre id="display-test"/>
        </div>
      </div>
    </div>
  </body>
</html>
